/* DiskUse.cmd, Version 3.01 for OS/2       */
/* Display diskspace used by subdirectories */
/* Written by Rob van der Woude             */
/* http://www.robvanderwoude.com            */

/* Initialize RexxUtil */
call RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
call SysLoadFuncs

/* Initialize RexxLib */
if RxFuncQuery( "RexxLibRegister" ) <> 0 then do
	call RxFuncAdd "RexxLibRegister", "RexxLib", "RexxLibRegister"
	call RexxLibRegister
end

/* Command line parsing */
parse upper arg startdir
if pos( "?", startdir ) > 0 then call Syntax
select
	when startdir = "" then fdir = directory( )
	when startdir = "." then fdir = directory( )
	when startdir = ".." then fdir = directory( ".\..\." )
	otherwise do
		call SysFileTree startdir, "exist.", "DO"
		if exist.0 <> 1 then do
			call Syntax "Specified startdir not found: "||startdir
		end
		fdir = exist.1
	end
end
fdir = strip( fdir, "T", "\" )
fdlen = length( fdir ) + 1

/* Display total file size for start directory */
call SysFileTree fdir||"\*", "files.", "F"
totalsize = 0
if files.0 > 0 then do j = 1 to files.0
	parse value files.j with . . fsize . files.j
	files.j = strip( files.j )
	totalsize = totalsize + fsize
end
say ".\="||totalsize

/* Display total file size for all subdirectories */
call SysFileTree fdir||"\*", "fdirs.", "DO"
if fdirs.0 > 0 then do
	if RxFuncQuery( "ArraySort" ) = 0 then call ArraySort "fdirs."
	do i = 1 to fdirs.0
		call SysFileTree fdirs.i||"\*", "files.", "FS"
		totalsize = 0
		if files.0 > 0 then do j = 1 to files.0
			parse value files.j with . . fsize . files.j
			files.j = strip( files.j )
			totalsize = totalsize + fsize
		end
		say substr( fdirs.i, fdlen + 1 )||"="||totalsize
	end
end
EXIT 0


Syntax:
	msg = arg( 1 )
	say
	say "DiskUse, Version 3.01 for OS/2"
	say "Display diskspace used by subdirectories"
	say "Written by Rob van der Woude"
	say "http://www.robvanderwoude.com"
	if msg <> "" then do
		say
		say msg
	end
	say
	say "Usage:  DISKUSE  [ startdir ]"
	EXIT 1
return
